#include "exthelp.hpp"

#define LenCurWord    1024    /*.  墠뢠 ᫮*/
#define MaxLenPath    1024
#define MaxNumItems   1024
#define MaxNameItem   70

static char DefWord1Str[] = "0123456789_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"; //ᨬ ᫮(⨭) -㬮砭
static char DefWord2Str[] = "񦧨"; //ᨬ ᫮(ਫ) -㬮砭 

static char *GetMsg(int MsgId)
{
  return(ExtHelpInfo.GetMsg(ExtHelpInfo.ModuleNumber,MsgId));
}

typedef struct ProjectItem{
   char   PathItem[ MaxLenPath  ];//  
}ProjectItem;

static ProjectItem pi[MaxNumItems];       //ᨢ  .ଠ樥  ⠬ ஥
static struct FarMenuItem mi[MaxNumItems];//ᨢ ⮢   FAR

// OEM-ਠ
static int toupcOEM(int ch )
{
   ch &= 0xFF;

   if( ch >= 'a' && ch <= 'z' )
        return  ch - ('a' - 'A');
   else if( ch >= (unsigned char)'' && ch <= (unsigned char)'')
        return  ch - ('' - '');
   else if( ch >= (unsigned char)'' && ch <= (unsigned char)'')
        return  ch - ('' - '');
   else if( ch == '' )
        return '';
   else return  ch;
}

static int ReadHelpMenu( char *ext ) {

   char *str;
   char StrEnd[256];
   int Total = 0;
   char StrTmp[1024], StrTmpExt[1024];

   strcpy(StrEnd, GetMsg( MBegItemProject )); 

   for( int i = 1; (strcmp( (str = GetMsg( MBegItemProject + i )), StrEnd ) && i <= MaxNumItems); i++ ){

      strcpy( StrTmp, str );
      for (int q = 0;*(StrTmp+q); q++)
         *(StrTmp+q) = (char)toupcOEM( *(StrTmp+q) );
      strcpy( StrTmpExt, ext );
      for (int q = 0;*(StrTmpExt+q); q++)
         *(StrTmpExt+q) = (char)toupcOEM( *(StrTmpExt+q) );

      if( strstr( StrTmp, "EXT:" ) != NULL && (strstr( StrTmp, StrTmpExt ) != NULL || *ext == '\0' ) ){

         int j;
         for( j = 0; (strcmp( (str = GetMsg( MBegItemProject+i+j+1 )), StrEnd ) && strstr( str, "ext:" ) == NULL && j <= MaxNumItems); j++ )
         {
           memset( &mi[Total+j],0,sizeof(struct FarMenuItem));
           strncpy( mi[Total+j].Text, str, MaxNameItem );

           strncpy( pi[Total+j].PathItem, str, MaxLenPath  );
         }
         if( *ext != '\0' )
            return j;
         else{
            Total += j;
            continue;
         }
      }
   }
   return Total;
}

void ConvertToOEM( char *str ){
     EditorConvertText ect;
     ect.Text       = str;
     ect.TextLength = strlen(str);
     //
     ExtHelpInfo.EditorControl( ECTL_EDITORTOOEM, &ect );
}

//஢ઠ  ᨬ-ࠧ⥫
static CheckDelSymbol( char Symbol ){
   int stat = 1;
   char StrSymb[2] = { Symbol, '\0' };
   //⨬ ᨬ  OEM
   ConvertToOEM( StrSymb );
   Symbol = StrSymb[0];

   //᫨  -ᨬ  室  祭 ᨬ ப
   if( (strchr( DefWord1Str, Symbol )  || strchr( DefWord2Str, Symbol )) )
      stat = 0;                  

   return stat;
}

//墠뢠 楫 ᫮  ⥪饩 樨  ।
static void GetCurWord( char *CurWord, char *StringText, int StringLength, int CurPos, int *BegPos ){

   if( StringLength > CurPos ){
     char *CurText = StringText + CurPos;
  
     if( *CurText && *CurText != ' ' && *CurText != '\n' && *CurText != '\t' && *CurText != '\r' ){
  
        char *EndWord = CurText;
        while( *EndWord && !CheckDelSymbol( *EndWord) ) EndWord++;
     
        char *BegWord = CurText;
        while( *BegWord && (BegWord-StringText) >= 0 && !CheckDelSymbol( *BegWord) ) BegWord--;
        if( BegWord != CurText ) BegWord++;
     
        if( *BegWord != '\0' ){
           if( (EndWord-BegWord) < LenCurWord )
              strncpy( CurWord, BegWord, (EndWord-BegWord) );
           else
              strncpy( CurWord, BegWord, LenCurWord-1 );

           if( *BegPos ) *BegPos = BegWord - StringText;//AV 02.12.99

           ConvertToOEM( CurWord );
        }
     }
   }
}

//*******************************************************************
// 맮  ஥
//*******************************************************************
static BOOL GetHelp( void ){

   struct EditorInfo ei;
   ExtHelpInfo.EditorControl(ECTL_GETINFO,&ei);
   char PathForHelpFile[1024] = "";
   char ext[256] = "";
   char *PosEnd;

   if( (PosEnd = strrchr(ei.FileName,'.')) != NULL ){
      strcpy( ext, PosEnd+1 );
   }    

   int NumHelps = ReadHelpMenu( ext );

   if( !NumHelps )
      NumHelps = ReadHelpMenu( "" );

   if( NumHelps > 0 ){
      struct EditorGetString str;
      char KeyWord[LenCurWord] = "";
      int BegPos = -1;
      str.StringNumber = -1;// 祭 ⥪饩 ப
      ExtHelpInfo.EditorControl( ECTL_GETSTRING, &str );
      GetCurWord( KeyWord, str.StringText, str.StringLength, ei.CurPos, &BegPos );     

      if( NumHelps > 1 ){
         mi[0].Selected=TRUE;
         int MenuCode=ExtHelpInfo.Menu(ExtHelpInfo.ModuleNumber,-1,-
               1,0,FMENU_WRAPMODE,
               GetMsg(MExtHelpTitle),NULL,
               NULL,NULL,NULL,
               mi,
               NumHelps );
         if (MenuCode<0)
           return false;
         else strcpy( PathForHelpFile, pi[MenuCode].PathItem );

      }else
         strcpy( PathForHelpFile, pi[0].PathItem );         

      return WinHelp(
       GetForegroundWindow(),    // handle of window requesting Help 
       PathForHelpFile,          // address of directory-path string 
       HELP_PARTIALKEY,          // type of Help 
       (DWORD)KeyWord            // additional data 
      );
   }
   return false;
}

//********************************************************************
//    
//********************************************************************

void WINAPI _export SetStartupInfo(struct PluginStartupInfo *ExtHelpInfo)
{

  ::ExtHelpInfo=*ExtHelpInfo;


}

#pragma argsused
HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item)
{
  GetHelp();
  return(INVALID_HANDLE_VALUE);
}

#pragma argsused
void WINAPI _export ClosePlugin(HANDLE hPlugin)
{
 //...q

}

//  editor-㣨
void WINAPI _export GetPluginInfo(struct PluginInfo *ExtHelpInfo)
{
  ExtHelpInfo->StructSize=sizeof(*ExtHelpInfo);
  ExtHelpInfo->Flags=PF_EDITOR|PF_DISABLEPANELS;
  ExtHelpInfo->DiskMenuStringsNumber=0;
  static char *PluginMenuStrings[1];
  PluginMenuStrings[0]=GetMsg(MExtHelpTitle);

  ExtHelpInfo->PluginMenuStrings=PluginMenuStrings;
  ExtHelpInfo->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
}

int WINAPI _export Configure(int ItemNumber)
{
  switch(ItemNumber)
  {
    case 0:{
       //...
    }break;

  }
  return(FALSE);
}

